template<class DIMENS, class BASE>
class array_properties {
public:
    typedef tuple<DIMENS> index_type;
    typedef typename index_type::dimen dimen;
    typedef BASE value_type;
    typedef BASE &ref_type;
};

#define DEFINE_ARRAY_PROPERTIES(DIMENS,BASE) \
typedef typename array_properties<DIMENS,BASE>::index_type index_type; \
typedef typename array_properties<DIMENS,BASE>::dimen dimen; \
typedef typename array_properties<DIMENS,BASE>::value_type value_type; \
typedef typename array_properties<DIMENS,BASE>::ref_type ref_type; \

///////////////////////////////////////////////////////////////////////////

template<class DIMENS, class BASE, class C>
class base_array {
public:
    DEFINE_ARRAY_PROPERTIES(DIMENS, BASE);
private:
    index_type _bounds;
public:
    base_array() : _bounds() { }
    base_array(index_type bounds) : _bounds(bounds) { }
    C& bsp_restrict asLeaf() 
	{ return static_cast<C & bsp_restrict>(*this); }
    const C& bsp_restrict asLeaf() const 
	{ return static_cast<const C & bsp_restrict>(*this); }
    //
    index_type bounds() const { return _bounds; }
    void set_bounds(index_type new_bounds) { _bounds = new_bounds; }
    int size(int p) const { return _bounds.get(p); }
};

template<class DIMENS, class BASE, class C>
class array : public base_array<DIMENS,BASE,C> {
public:
    DEFINE_ARRAY_PROPERTIES(DIMENS, BASE);
    array() : base_array<DIMENS,BASE,C>() { }
    array(index_type bounds) : base_array<DIMENS,BASE,C>(bounds) { }
};

template<class BASE, class C>
class array<_1,BASE,C> : public base_array<_1,BASE,C> {
public:
    DEFINE_ARRAY_PROPERTIES(_1, BASE);
    array() : base_array<_1,BASE,C>() { }
    array(index_type bounds) : base_array<_1,BASE,C>(bounds) { }
    int size(int p) const { return base_array<_1,BASE,C>::size(p); }
    // Additional methods for vectors
    int size() const { return size(0); }
};
