///////////////////////////////////////////////////////////////////////////

struct proto_term_tag { };

template<class DIMENS, class BASE, class C>
class proto_term : 
    public array< DIMENS, BASE, C > {
public:
    DEFINE_ARRAY_PROPERTIES(DIMENS, BASE);
public:
    typedef array< DIMENS, BASE, C > array_type;
    typedef proto_term_tag term_tag;
    proto_term() : array_type() { }
    proto_term(index_type bounds) : array_type(bounds) { }
};

template <class I>
inline typename I::term_tag bsp_term_category(const I&) {
    typedef typename I::term_tag category;
    return category();
}

///////////////////////////////////////////////////////////////////////////

template<class V>
struct term_scalar_tag : public proto_term_tag { };

template<class V> class term_scalar_iterator_obj;

template<class V>
class term_scalar
    : public proto_term<  _0, V, term_scalar<V> >
{
private:
    typedef proto_term<  _0, V, term_scalar<V> > base_term_type;
public:
    DEFINE_ARRAY_PROPERTIES(_0,V);
public:
    V *p;
    term_scalar() : p(0) { }
    term_scalar(V *p) : base_term_type(index_type()), p(p) { }
    term_scalar(V &x) : base_term_type(index_type()), p(&x) { }
    ~term_scalar() {}
    operator V () const { return *p; }
    //operator ref_type () { return *p; }
    V operator=(const V &v) { *p = v; return *p; }
    V operator+=(const V &v) { *p += v; return *p; }
    typedef term_scalar_tag<V> term_tag;
};

///////////////////////////////////////////////////////////////////////////

template<class C, class N, class I, class E>
struct term_nesting_tag : public proto_term_tag { };

template<class C, class N, class I, class E>
class term_nesting_iterator_obj;

template<class C, class N, class I, class E>
class term_nesting
    : public proto_term<_plus(N,typename E::dimen), typename E::value_type, C>
{
public:
    DEFINE_ARRAY_PROPERTIES(_plus(N,typename E::dimen),
			    typename E::value_type);
    typedef proto_term<dimen,value_type, C> base_term_type;
public:
    typedef N local_dimen;
    typedef I iterator_type;
    typedef typename I::key_type key_type;
    typedef E subterm_type;
protected:
    // for term_nesting<>
    //     iterator_type v_tn_begin() const;
    //     iterator_type v_tn_end() const;
    //     iterator_type v_tn_search(const key_type&i, bool force_p);
    //     E v_tn_subterm(I it);
    iterator_type v_tn_search(const key_type&i, bool force_p) {
	(void)force_p;
	iterator_type it = std::search(begin(), end(), i);
 	if (it == end()) { assert(!force_p); }
	return it;
    }
public:
    term_nesting() : base_term_type() { }
    term_nesting(index_type bounds) : base_term_type(bounds) { }
    ~term_nesting() {}
    I begin() const { return asLeaf().v_tn_begin(); }
    I end() const { return asLeaf().v_tn_end(); }
    I search(const key_type&i, bool force_p)
	{ return asLeaf().v_tn_search(i,force_p); }
    const E subterm(I it) const
	{ return const_cast<term_nesting<C,N,I,E>&>(*this).asLeaf().v_tn_subterm(it); }
    E subterm(I it) { return asLeaf().v_tn_subterm(it); }
    typedef term_nesting_tag<C,N,I,E> term_tag;
};
